#include "img_tool.h"

#include <stdio.h>

#include "typedfs.h"


void OrR(void *R1, const void *R2, unsigned maxX) // R1:=R1 or R2
{
  while(maxX>=4)
  {
    *(uint32_t*)R1 |= *(uint32_t*)R2;
    R1 = (uint32_t*)R1 + 1;
    R2 = (uint32_t*)R2 + 1;
    maxX -= 4;
  }
  while(maxX>=1)
  {
    *(int8_t*)R1 |= *(int8_t*)R2;
    R1 = (int8_t*)R1 + 1;
    R2 = (int8_t*)R2 + 1;
    maxX--;
  }
}


void AndR(void *R1, const void *R2, unsigned maxX) // R1:=R1 and R2
{
  while(maxX>=4)
  {
    *(uint32_t*)R1 &= *(uint32_t*)R2;
    R1 = (uint32_t*)R1 + 1;
    R2 = (uint32_t*)R2 + 1;
    maxX -= 4;
  }
  while(maxX>=1)
  {
    *(int8_t*)R1 &= *(int8_t*)R2;
    R1 = (int8_t*)R1 + 1;
    R2 = (int8_t*)R2 + 1;
    maxX--;
  }
}


/** In place right shift R1:=R1 shr 1 */
void ShrR(void *R, unsigned maxX)
{
int8_t PrevVal, val;
  if(R==NULL || maxX==0) return;

  PrevVal = (*(int8_t*)R & 0x80);
  while(maxX-->0)
  {
    val = *(int8_t*)R;
    *(int8_t*)R = PrevVal | (val>>1);
    R = (int8_t*)R + 1;
    PrevVal = (val & 1) ? 0x80 : 0;
  }
}


/** In place left shift R1:=R1 shl 1 */
void ShlR(void *R, unsigned maxX, unsigned char LastBit)
{
int8_t PrevVal, val;
  if(R==NULL || maxX==0) return;

  R = (int8_t*)R + maxX - 1;

  PrevVal = *(int8_t*)R & LastBit;
  while(maxX-->0)
  {
    val = *(int8_t*)R;
   *(int8_t*)R = PrevVal | (val<<1);
   R = (int8_t*)R - 1;
   PrevVal = (val & 0x80) ? 1 : 0;
  }
}


void MaxU8(unsigned char *R1, const unsigned char *R2, unsigned size)
{
  while(size-->0)
  {
    if(*R2 > *R1) *R1=*R2;
    R1++;
    R2++;
  }
}


void MinU8(unsigned char *R1, const unsigned char *R2, unsigned size)
{
  while(size-->0)
  {
    if(*R2 < *R1) *R1=*R2;
    R1++;
    R2++;
  }
}


void MaxU16(unsigned char *R1, const unsigned char *R2, unsigned size)
{
  while(size-->0)
  {
    if(*(uint16_t*)R2 > *(uint16_t*)R1) *(uint16_t*)R1=*(uint16_t*)R2;
    R1+=2;
    R2+=2;
  }
}


void MinU16(unsigned char *R1, const unsigned char *R2, unsigned size)
{
  while(size-->0)
  {
    if(*(uint16_t*)R2 < *(uint16_t*)R1) *(uint16_t*)R1=*(uint16_t*)R2;
    R1+=2;
    R2+=2;
  }
}
